Subject: bug#35781: Discrepancies between xftfont.c and ftcrfont.c

From: Alex Gramiak <[email-masked]>
Date: Sun, 19 May 2019 13:48:33 -0600

Kévin Le Gouguec <[email-masked]> writes:

> retitle 35781 Make Cairo build obey hint-style font setting
> thanks
>
> I am nowhere close to a proper fix, but at least I think I am starting
> to get a clearer picture of the situation.
>
> The distribution installed on my laptop sets the "hint-style" font
> setting to "slight" in both ~/.config/fontconfig/fonts.conf and
> ~/.Xresources.  AFAICU fontconfig and X resources are two (competing?)
> mechanisms that tell graphical applications what fonts and font
> settings they should use.  OK.
>
> I am still studying the lay of the land; I see that xftfont_open in
> xftfont.c calls xftfont_add_rendering_parameters, which has a bunch of
> hint-style-related code calling fontconfig functions, while
> ftcrfont_open in ftcrfont.c seems blissfully unaware of fontconfig.
>
> At this point I am assuming that only ftcrfont.c is used in Cairo
> builds, since config.h does not define HAVE_XFT, but my knowledge of
> font management in Emacs is pretty lacking so I will have to check this
> assumption.
>
> As I said, I am far from being able to cook up any sort of patch at
> this point; I still intend to keep digging Soonish™, but since that
> may take a while, I figured I would update this report with whatever
> information I gathered this far for posterity.

Perhaps ftcrfont.c could use FcPatternAddFTFace, FcFontMatch,
cairo_ft_font_face_create_for_pattern, and otherwise the same pattern
building as xftfont.c.